//package toast;
import java.lang.Math.*;
import java.lang.*;
import javax.swing.*;
import java.util.*;
import java.awt.*;

public class Connection extends Object {
  private Unit    target;
  private String  site;
  private Unit    source;
  private String  weight;


  /** Constructor for Connection.
   * @param target Unit-Object, the target of the connection
   * @param source Unit-Object, the source of the connection
   * @param weight float weight of the connection
   * @param site String containing the site of the connection

   */
  public Connection(Unit target , Unit source, String weight, String site) {
     this.target = target;
     this.source = source;
     this.weight = weight;
     this.site = site;
  }


  /** the paint method draws the connection according to the parameter Properties p.
   * @param g The Graphics-Object which determines where to draw.
   * @param p Properties-Object with general Net-Drawing-Properties.
   */
  public void paint(Graphics g, Properties p) {
     g.setColor(Color.black);
     boolean thick = source.isActivated() | target.isActivated();
     drawLine(thick, g, source.getX(),source.getY(),target.getX(),target.getY());
  }

  public void paintPS(PSGr g, Properties p) {
      g.setColor(Color.black);
      boolean thick = source.isActivated() | target.isActivated(); 
      if (thick) g.emitThis("2 setlinewidth");
      if (source.getNo() != target.getNo()) {
	  int x1 = source.getX();
	  int y1 = source.getY();
	  int x2 = target.getX();
	  int y2 = target.getY();

	  float l = (float)Math.sqrt( (x1-x2)*(x1-x2)+(y1-y2)*(y1-y2) );
          float nx = (float) (x2-x1)/l; 
          float ny = (float) (y2-y1)/l; 
    
          float p1x = (x1+x2)/2 - nx * 7;
          float p1y = (y1+y2)/2 - ny * 7;
          float p2x = p1x;
          float p2y = p1y;

          p1x += ny*5;
          p1y -= nx*5;

          p2x -= ny*5;
          p2y += nx*5;

          //g.drawLine(source.getX(),source.getY(),target.getX(),target.getY());
          g.drawLine((int)p1x,(int)p1y,(x1+x2)/2,(y1+y2)/2);
          g.drawLine((int)p2x,(int)p2y,(x1+x2)/2,(y1+y2)/2);
          g.drawLine(x1,y1,x2,y2);

      } else {
	  int x = source.getX();
	  int y = source.getY();
	  g.drawLine(x,y,x+20,y);
          g.drawArc(x,y,40,40,180,270);
          g.drawLine(x,y,x,y+20);
      }
      if (thick) g.emitThis("1 setlinewidth");
  }


  public void paintThumbnail(Graphics g) {
     g.setColor(Color.gray);
     g.drawLine(source.getThumbnailX(),source.getThumbnailY(),target.getThumbnailX(),target.getThumbnailY());
  }

  public String toString() {
     String s = "  Target: "+target.getNo()+"  Source: "+source.getNo()+"  Weight: "+weight+"  Site: "+site+"\n" ;
     return  s;
  }


  private void drawLine ( boolean thick, Graphics g, int x1, int y1, int x2, int y2) {
      Graphics2D g2 = (Graphics2D) g;
      BasicStroke wideStroke = new BasicStroke(2.5f);
      BasicStroke stroke = new BasicStroke(1.0f);

      if (x1 != x2 | y1 != y2) {
          float l = (float)Math.sqrt( (x1-x2)*(x1-x2)+(y1-y2)*(y1-y2) );
          float nx = (float) (x2-x1)/l;
          float ny = (float) (y2-y1)/l; 
    
          float p1x = (x1+x2)/2 - nx * 7;
          float p1y = (y1+y2)/2 - ny * 7;
          float p2x = p1x;
          float p2y = p1y;

          p1x += ny*5;
          p1y -= nx*5;

          p2x -= ny*5;
          p2y += nx*5;


          if (thick) g2.setStroke(wideStroke);
          g2.drawLine((int)p1x,(int)p1y,(x1+x2)/2,(y1+y2)/2);
          g2.drawLine((int)p2x,(int)p2y,(x1+x2)/2,(y1+y2)/2); 
          g2.drawLine(x1,y1,x2,y2); 
    
          g2.setStroke(stroke);
      } else if (source.getNo() == target.getNo()) {
	  if (thick) g2.setStroke(wideStroke);
	  g2.drawLine(x1,y1,x1+20,y1);
	  g2.drawArc(x1,y1,40,40,180,270);
	  g2.drawLine(x1,y1,x1,y1+20);
	  g2.setStroke(stroke);
      }
  }

  public Connection getConnection(Point p) {
	// Abstand Punkt / Gerade zwischen Start und EndUnit berechnen
	// ist der Abstand nicht klein genug, return null
	return null;
  }	

}
